/*
 * 15-821 Coda
 * Auth Module
 * Anoop Jaishankar, Sang Kil Cha, Jaeyoon Chong
 */

#ifndef CODA_AUTHORIZATION_H
#define CODA_AUTHORIZATION_H

#include <gtk/gtk.h>
#include <string.h>
#include <hildon/hildon-program.h>
#include "hildon-file-chooser-dialog.h"
#include "hildon-file-selection.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>

#define CLOG_PROGRAM "/usr/bin/clog"
#define CTOKENS_PROGRAM "/usr/bin/ctokens"

/* Application UI data struct */
typedef struct _AuthData AuthData;
struct _AuthData {
        HildonProgram *program;
        HildonWindow *window;
	GtkWidget * label;
	GtkWidget * main_vbox;
	
	GtkWidget * auth_dialog;
	GtkWidget * auth_hbox1;
	GtkWidget * auth_hbox2;
	GtkWidget * auth_hbox3;
	GtkWidget * user_name_label;
	GtkWidget * user_name;
	GtkWidget * realm_label;
	GtkWidget * realm_name;
	GtkWidget * password_label;
	GtkWidget * password;
	
        /* Menu stuff */
        GtkMenu * main_menu;
        GtkWidget * menu_item_login;
        GtkWidget * menu_item_quit;
};

void cb_login_quit(GtkWidget *w, AuthData * data);
void alert(char* message);
int ctokens_verify(const char* realm);
int clog_verify(const char *uname, const char* realm, const char* passwd);
void coda_login_dialog(char *uri, HildonFileSystemModel *model_in);
int authorize_user(AuthData * data);
void login_dialog_init(AuthData * data );

#endif
